#region Copyright Syncfusion Inc. 2001 - 2012
//
//  Copyright Syncfusion Inc. 2001 - 2012. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Diagnostics;

using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.DocToPDFConverter;
using Syncfusion.OfficeChart;
using Syncfusion.OfficeChartToImageConverter;
using Syncfusion.Pdf;

namespace EssentialDocIOSamples
{

    public class Form1 : System.Windows.Forms.Form
    {
        #region Private Members

        private ToolTip toolTip1;
        private Button button1;
        private PictureBox pictureBox1;
        private Label label2;
        private CheckBox checkBox1;
        private NumericUpDown numericUpDown1;
        private CheckBox two;
        private CheckBox one;
        private IContainer components;

        #endregion

        #region Constructor, Main and Dispose
        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            Application.EnableVisualStyles();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }
        #endregion

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.button1 = new System.Windows.Forms.Button();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.label2 = new System.Windows.Forms.Label();
            this.checkBox1 = new System.Windows.Forms.CheckBox();
            this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
            this.two = new System.Windows.Forms.CheckBox();
            this.one = new System.Windows.Forms.CheckBox();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button1.BackColor = System.Drawing.Color.Transparent;
            this.button1.FlatAppearance.BorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(192)))), ((int)(((byte)(128)))));
            this.button1.FlatAppearance.MouseDownBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(224)))), ((int)(((byte)(192)))));
            this.button1.FlatAppearance.MouseOverBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(192)))));
            this.button1.Image = ((System.Drawing.Image)(resources.GetObject("button1.Image")));
            this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.button1.Location = new System.Drawing.Point(327, 395);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(220, 46);
            this.button1.TabIndex = 62;
            this.button1.Text = "Generate V1";
            this.button1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.button1.UseVisualStyleBackColor = false;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // pictureBox1
            // 
            this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Top;
            this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
            this.pictureBox1.Location = new System.Drawing.Point(0, 0);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(1549, 179);
            this.pictureBox1.TabIndex = 60;
            this.pictureBox1.TabStop = false;
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(161)));
            this.label2.ForeColor = System.Drawing.SystemColors.ControlText;
            this.label2.Location = new System.Drawing.Point(14, 198);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(732, 81);
            this.label2.TabIndex = 68;
            this.label2.Text = "Click the button to view the Word document generated by Essential DocIO. Please n" +
    "ote that MS Word Viewer or MS Word is required to view the resultant document.";
            // 
            // checkBox1
            // 
            this.checkBox1.AutoSize = true;
            this.checkBox1.Location = new System.Drawing.Point(24, 284);
            this.checkBox1.Name = "checkBox1";
            this.checkBox1.Size = new System.Drawing.Size(77, 29);
            this.checkBox1.TabIndex = 70;
            this.checkBox1.Text = "BIK";
            this.checkBox1.UseVisualStyleBackColor = true;
            // 
            // numericUpDown1
            // 
            this.numericUpDown1.Location = new System.Drawing.Point(122, 282);
            this.numericUpDown1.Minimum = new decimal(new int[] {
            1,
            0,
            0,
            0});
            this.numericUpDown1.Name = "numericUpDown1";
            this.numericUpDown1.Size = new System.Drawing.Size(240, 31);
            this.numericUpDown1.TabIndex = 71;
            this.numericUpDown1.Value = new decimal(new int[] {
            1,
            0,
            0,
            0});
            // 
            // two
            // 
            this.two.AutoSize = true;
            this.two.Location = new System.Drawing.Point(146, 327);
            this.two.Name = "two";
            this.two.Size = new System.Drawing.Size(86, 29);
            this.two.TabIndex = 72;
            this.two.Text = "Dwa";
            this.two.UseVisualStyleBackColor = true;
            // 
            // one
            // 
            this.one.AutoSize = true;
            this.one.Location = new System.Drawing.Point(24, 327);
            this.one.Name = "one";
            this.one.Size = new System.Drawing.Size(103, 29);
            this.one.TabIndex = 72;
            this.one.Text = "Jeden";
            this.one.UseVisualStyleBackColor = true;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(10, 24);
            this.BackColor = System.Drawing.Color.White;
            this.ClientSize = new System.Drawing.Size(1549, 623);
            this.Controls.Add(this.one);
            this.Controls.Add(this.two);
            this.Controls.Add(this.numericUpDown1);
            this.Controls.Add(this.checkBox1);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.pictureBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Generate Word";
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        #region Button_Click Event
        private void button1_Click(object sender, System.EventArgs e)
        {
            //Sets ClearFields to true to remove empty mail merge fields from document
           
            string inputPath = Application.StartupPath + @"\..\..\Data\Template1.docx";
            //Creates a new document
            WordDocument wordDocument = new WordDocument(inputPath);

            wordDocument.MailMerge.RemoveEmptyGroup = true;
            wordDocument.MailMerge.RemoveEmptyParagraphs = true;
            wordDocument.MailMerge.ClearFields = true;
            wordDocument.MailMerge.BeforeClearField += BeforeClearFieldEvent;

            List<DataTable> secondaries = new List<DataTable> { GetDataSourcesDataTable(), GetProductsDataTable(), GetUsersDataTable(), GetBIKDataTable() }; //this comes from my database

            foreach (var table in secondaries)
            {
                wordDocument.MailMerge.ExecuteGroup(table);
            }



            wordDocument.MailMerge.Execute(GetPrimaryDataTable(true));

            wordDocument.UpdateDocumentFields();



            WChart chart = wordDocument.FindChartByTitle("Test");

            //Data source for the charts
            int[] dataValues = new int[] { 100, 20, 40, 80 };
            //set labels
            chart.ChartData.SetValue(2, 1, "A");
            chart.ChartData.SetValue(3, 1, "B");
            chart.ChartData.SetValue(4, 1, "C");
            chart.ChartData.SetValue(5, 1, "D");
            //Sets the values of the charts from data source
            chart.ChartData.SetValue(2, 2, dataValues[0]);
            chart.ChartData.SetValue(3, 2, dataValues[1]);
            chart.ChartData.SetValue(4, 2, dataValues[2]);
            chart.ChartData.SetValue(5, 2, dataValues[3]);

            //Sets data label
            chart.Series[0].DataPoints.DefaultDataPoint.DataLabels.IsValue = true;

            chart.ChartTitle = "Works!";

            chart.Refresh();

            wordDocument.ChartToImageConverter = new ChartToImageConverter {ScalingMode = ScalingMode.Normal};

            DocToPDFConverter converter = new DocToPDFConverter {Settings = {EnableFastRendering = true}};

            PdfDocument pdfDocument = converter.ConvertToPDF(wordDocument);
            pdfDocument.Save("Sample1.pdf");

            converter.Settings.EmbedFonts = true;

            converter.Settings.OptimizeIdenticalImages = true;

            pdfDocument.Close(true);

            wordDocument.Save("Sample1.docx");
            wordDocument.Close();

            //Message box confirmation to view the created document.
            if (MessageBox.Show("Do you want to view the MS Word document?", "Document has been created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) !=
                DialogResult.Yes) return;
            try
            {
                //Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
                Process.Start("Sample1.pdf");
            }
            catch (Win32Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        private DataTable GetPrimaryDataTable( bool thereAreUsers)
        {
            DataTable table = new DataTable {TableName = "Primary"};
            //Adds fields to the Products table
            table.Columns.Add("ThereAreUsers", typeof(string));
            table.Columns.Add("Imie", typeof(string));
            table.Columns.Add("Nazwisko", typeof(string));
            table.Columns.Add("PESEL", typeof(string));
            table.Columns.Add("DataGenerowania", typeof(string));
            table.Columns.Add("MaBIK", typeof(string));
            table.Columns.Add("Jeden", typeof(string));
            table.Columns.Add("Dwa", typeof(string));
            //Inserts values to the tables

            var row = table.NewRow();
            row["ThereAreUsers"] = thereAreUsers?"Yes":"";
            row["Imie"] = "Marcin";
            row["Nazwisko"] = "Testowy";
            row["PESEL"] = "22222222222";
            row["DataGenerowania"] = DateTime.Now.ToString("dd.MM.yyyy");
            row["MaBIK"] = checkBox1.Checked ? "Tak" : "Nie";
            row["Jeden"] = one.Checked ? "Tak" : "Nie";
            row["Dwa"] = two.Checked ? "Tak" : "Nie";
            table.Rows.Add(row);

            return table;
        }

        private DataTable GetDataSourcesDataTable()
        {

            string[] sources = { "Baza danych YOLO S.A.", "Biuro Informacji Gospodarczej InfoMonitor S.A.", "Krajowy Rejestr Dugw Biuro Informacji Gospodarczej S.A." };
            //Adds new Tables to the data set
            DataTable table = new DataTable {TableName = "ZrodlaDanych"};
            //Adds fields to the Products table
            table.Columns.Add("Nazwa");
            //Inserts values to the tables
            foreach (string product in sources)
            {
                var row = table.NewRow();
                row["Nazwa"] = product;
                table.Rows.Add(row);
            }
            return table;
        }

        private DataTable GetProductsDataTable()
        {
            //List of syncfusion products name
            string[] products = { "DocIO", "PDF", "XlsIO" };
            //Adds new Tables to the data set
            DataRow row;
            DataTable table = new DataTable();
            //Adds fields to the Products table
            table.TableName = "Products";
            table.Columns.Add("ProductName");
            table.Columns.Add("Binary");
            table.Columns.Add("Source");
            //Inserts values to the tables
            foreach (string product in products)
            {
                row = table.NewRow();
                row["ProductName"] = string.Concat("Essential ", product);
                row["Binary"] = "$895.00";
                row["Source"] = "$1,295.00";
                table.Rows.Add(row);
            }
            return table;
        }

        private DataTable GetBIKDataTable()
        {
            //List of syncfusion products name
            string[] products = { "DocIO", "PDF", "XlsIO" };
            //Adds new Tables to the data set
            DataRow row;
            DataTable table = new DataTable();
            //Adds fields to the Products table
            table.TableName = "BIKZobowiazania";
            table.Columns.Add("NrZobowiazania");
            table.Columns.Add("Rodzaj");
            table.Columns.Add("Relacja");
            table.Columns.Add("PierwotnaKwota");
            //Inserts values to the tables
            for (var index = 1; index <= numericUpDown1.Value; index++)
            {
                row = table.NewRow();
                row["NrZobowiazania"] = string.Concat("Zobowizanie ", index);
                row["Rodzaj"] = "Kredyt";
                row["Relacja"] = "Gwny kredytobiorca";

                table.Rows.Add(row);
            }

            return table;
        }

        private DataTable GetUsersDataTable()
        {
            //List of syncfusion products name
            string[] products = { "John", "Sam", "Dave" };
            //Adds new Tables to the data set
            DataRow row;
            DataTable table = new DataTable();
            //Adds fields to the Products table
            table.TableName = "Users";
            table.Columns.Add("UserName");
            table.Columns.Add("Age");
            table.Columns.Add("City");
            //Inserts values to the tables
            foreach (string product in products)
            {
                row = table.NewRow();
                row["UserName"] = string.Concat("Sir ", product);
                row["Age"] = "33";
                row["City"] = "Warsaw";
                table.Rows.Add(row);
            }
            return table;
        }

        //Gets data
        public  List<Employee> GetReports()
        {
            //Creates mail merge Details
            List<Customer> customer1 = new List<Customer>();
            customer1.Add(new Customer(string.Empty));
            //Creates AgedReceivables reports
            List<Employee> reports = new List<Employee>();
            reports.Add(new Employee("1", customer1));

            List<Customer> customer2 = new List<Customer>();
            customer2.Add(new Customer("Simon"));

            reports.Add(new Employee("2", customer2));
            return reports;
        }
        /// <summary>
        /// Gets report details
        /// </summary>
        public class Employee
        {
            public string ChapterNumber { get; set; }
            public List<Customer> Customer { get; set; }
            public Employee(string name, List<Customer> cutsomer)
            {
                ChapterNumber = name;
                Customer = cutsomer;
            }
        }
        /// <summary>
        /// Gets mail merge details
        /// </summary>
        public class Customer
        {
            public string ChapterName { get; set; }
           
            public Customer(string chapterName)
            {
                ChapterName = chapterName;
            }
        }
        /// <summary>
        /// Performs event to set field value
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        private  void BeforeClearFieldEvent(object sender, BeforeClearFieldEventArgs args)
        {
            if (args.FieldName == "ThereAreUsers")
            {
                //If field value is empty, you can set whether the unmerged merge field can be clear or not
                args.ClearField = true;
            }
        }
        #endregion

        private void button2_Click(object sender, EventArgs e)
        {
            string inputPath = Application.StartupPath + @"\..\..\Data\Template.doc";
            //Creates a new document
            WordDocument wordDocument = new WordDocument(inputPath);

            wordDocument.MailMerge.RemoveEmptyGroup = true;
            wordDocument.MailMerge.RemoveEmptyParagraphs = true;
            wordDocument.MailMerge.ClearFields = true;
            wordDocument.MailMerge.BeforeClearField += BeforeClearFieldEvent;

            List<DataTable> secondaries = new List<DataTable> { GetProductsDataTable() }; //this comes from my database

            foreach (var table in secondaries)
            {
                wordDocument.MailMerge.ExecuteGroup(table);
            }

            wordDocument.MailMerge.Execute(GetPrimaryDataTable(false));

            wordDocument.UpdateDocumentFields();

            wordDocument.Save("Sample2.doc");
            wordDocument.Close();

            //Message box confirmation to view the created document.
            if (MessageBox.Show("Do you want to view the MS Word document?", "Document has been created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) !=
                DialogResult.Yes) return;
            try
            {
                //Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
                Process.Start("Sample2.doc");
            }
            catch (Win32Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

        }
    }

    public static class WordDocumentExtensions
    {
        public static T SingleOrDefault<T>(this WordDocument wordDocument, Func<T, bool> func)
        {
            foreach (WSection section in wordDocument.Sections)
            {
                foreach (WParagraph paragraph in section.Paragraphs)
                {
                    var tmp = paragraph.ChildEntities.OfType<T>();

                    var item = paragraph.ChildEntities.OfType<T>().SingleOrDefault(func);
                    if (item != null)
                    {
                        return item;
                    }
                }
            }

            return default(T);
        }

        public static WChart FindChartByTitle(this WordDocument wordDocument, string chartTitle)
        {
            if (wordDocument == null) throw new NullReferenceException($"{nameof(wordDocument)} can't be null");
            var chart = wordDocument.SingleOrDefault<WChart>(c => c.ChartTitle == chartTitle);
            return chart;
        }
    }
}

